<template>
  <div class="py-8 px-4 lg:py-16 lg:px-12">
    <UBreadcrumb :links="links" />
    <div class="py-8 px-4 mx-auto max-w-2xl lg:py-16">
      <h2 class="mb-4 text-xl font-bold text-gray-900 dark:text-white">
        Modifier {{ data.name }}
      </h2>
      <p>{{ error }}</p>
      <UForm :schema="schema" :state="state" @submit="onSubmit">
        <div class="grid gap-4 sm:grid-cols-2 sm:gap-6">
          <div class="sm:col-span-2">
            <UFormGroup label="Nom flux" name="flux-name">
              <UInput type="text" v-model="state.name" />
            </UFormGroup>
          </div>
          <div class="w-full">
            <UFormGroup label="Url flux" name="flux-url">
              <UInput type="text" v-model="state.flux_url" />
            </UFormGroup>
          </div>
          <div class="w-full">
            <UFormGroup label="Type flux" name="flux-type">
              <USelect v-model="state.type" :options="types" />
            </UFormGroup>
          </div>
          <div class="w-full">
            <UFormGroup label="Array 1 flux" name="flux-array-1">
              <UInput text="text" v-model="state.alert" />
            </UFormGroup>
          </div>
          <div class="w-full">
            <UFormGroup label="Array 2 flux" name="flux-array-2">
              <UInput text="text" v-model="state.alert_array" />
            </UFormGroup>
          </div>
          <div class="sm:col-span-2">
            <UFormGroup label="Array" name="flux-array">
              {{ alert_data }}
              <div class="flex justify-between my-5">
                <UInput text="text" v-model="state.alert_data"  class="w-full mr-5"/>
                <UButton @click="add" class="rounded-full">Add</UButton>
              </div>
            </UFormGroup>
          </div>
        </div>
        <div class="flex items-center space-x-4">
          <UButton type="submit" :loading="loading" class="text-white bg-primary-700 hover:bg-primary-800 focus:ring-4 focus:outline-none focus:ring-primary-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center dark:bg-primary-600 dark:hover:bg-primary-700 dark:focus:ring-primary-800">
            Enregistrer
          </UButton>
          <UButton type="button" @click="isModal = true" class="text-red-600 inline-flex items-center hover:text-white border border-red-600 bg-transparent hover:bg-red-600 focus:ring-4 focus:outline-none focus:ring-red-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center">
            <svg class="w-5 h-5 mr-1 -ml-1" fill="currentColor" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" d="M9 2a1 1 0 00-.894.553L7.382 4H4a1 1 0 000 2v10a2 2 0 002 2h8a2 2 0 002-2V6a1 1 0 100-2h-3.382l-.724-1.447A1 1 0 0011 2H9zM7 8a1 1 0 012 0v6a1 1 0 11-2 0V8zm5-1a1 1 0 00-1 1v6a1 1 0 102 0V8a1 1 0 00-1-1z" clip-rule="evenodd"></path></svg>
            Delete
          </UButton>
        </div>
      </UForm>
      <div id="deleteModal" tabindex="-1" aria-hidden="true" :class="isModal ? '' : 'hidden'" class="overflow-y-auto overflow-x-hidden fixed top-0 right-0 left-0 z-50 justify-center items-center w-full md:inset-0 h-modal md:h-full">
        <div class="relative p-4 w-full max-w-md h-full md:h-auto">
          <!-- Modal content -->
          <div class="relative p-4 text-center bg-white rounded-lg shadow dark:bg-gray-800 sm:p-5">
            <button type="button" @click="isModal = false" class="text-gray-400 absolute top-2.5 right-2.5 bg-transparent hover:bg-gray-200 hover:text-gray-900 rounded-lg text-sm p-1.5 ml-auto inline-flex items-center dark:hover:bg-gray-600 dark:hover:text-white" data-modal-toggle="deleteModal">
              <svg aria-hidden="true" class="w-5 h-5" fill="currentColor" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" d="M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z" clip-rule="evenodd"></path></svg>
              <span class="sr-only">Close modal</span>
            </button>
            <svg class="text-gray-400 dark:text-gray-500 w-11 h-11 mb-3.5 mx-auto" aria-hidden="true" fill="currentColor" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" d="M9 2a1 1 0 00-.894.553L7.382 4H4a1 1 0 000 2v10a2 2 0 002 2h8a2 2 0 002-2V6a1 1 0 100-2h-3.382l-.724-1.447A1 1 0 0011 2H9zM7 8a1 1 0 012 0v6a1 1 0 11-2 0V8zm5-1a1 1 0 00-1 1v6a1 1 0 102 0V8a1 1 0 00-1-1z" clip-rule="evenodd"></path></svg>
            <p class="mb-4 text-gray-500 dark:text-gray-300">Are you sure you want to delete this item?</p>
            <div class="flex justify-center items-center space-x-4">
              <button data-modal-toggle="deleteModal" @click="isModal = false" type="button" class="py-2 px-3 text-sm font-medium text-gray-500 bg-white rounded-lg border border-gray-200 hover:bg-gray-100 focus:ring-4 focus:outline-none focus:ring-primary-300 hover:text-gray-900 focus:z-10 dark:bg-gray-700 dark:text-gray-300 dark:border-gray-500 dark:hover:text-white dark:hover:bg-gray-600 dark:focus:ring-gray-600">
                No, cancel
              </button>
              <button type="submit" class="py-2 px-3 text-sm font-medium text-center text-white bg-red-600 rounded-lg hover:bg-red-700 focus:ring-4 focus:outline-none focus:ring-red-300 dark:bg-red-500 dark:hover:bg-red-600 dark:focus:ring-red-900">
                Yes, I'm sure
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <articles-flux v-if="dataLoading" :flux="data" />
  </div>
</template>

<script setup lang="ts">
import {useNuxtApp} from "#app";
import type {Api} from "~/types/api";
import {type InferType, object, string} from "yup";

const route = useRoute()
const nuxtApp = useNuxtApp()
const $api = nuxtApp.$api as Api
const data = ref({})
const error = ref('')
const loading = ref(false)
const links = ref()
const types = ['json', 'xml']
const alert_data = ref([])
const dataLoading = ref(false)

const schema = object({
  name: string().required(),
  type: string().required(),
  flux_url: string().required(),
  alert_array: string().required(),
  alert: string().required(),
  alert_data: string()
})

type Schema = InferType<typeof schema>

const state = reactive({
  name: '',
  type: '',
  flux_url: '',
  alert_array: '',
  alert: '',
  alert_data: ''
})

async function loadData () {
  try {
    loading.value = true
    data.value = await $api.getFluxById(route.params.id)
  } catch (err)  {
    error.value = err.message
  } finally {
    loading.value = false
    dataLoading.value = true
  }
}

onMounted(() => {
  loadData().then(() => {
    links.value =  [{
      label: 'Home',
      icon: 'i-heroicons-home',
      to: '/feed'
    }, {
      label: 'Flux',
      icon: 'i-heroicons-square-3-stack-3d',
      to: '/flux'
    }, {
      label: data.value.name,
      icon: 'i-heroicons-rectangle-group-solid'
    }]
    state.name = data.value.name,
    state.type = data.value.type,
    state.flux_url = data.value.flux_url,
    state.alert_array = data.value.alert_array,
    state.alert = data.value.alert,
    alert_data.value = data.value.alert_data
  })
})

const isModal = ref(false)


function add () {
  if (state.alert_data !== '') {
    alert_data.value.push(state.alert_data)
    state.alert_data = ''
    console.log(alert_data.value)
  }
}
</script>